"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const plugin_names_1 = require("./plugin-names");
function getPluginsArray(target) {
    if (Array.isArray(target)) {
        return target;
    }
    let options = target.options || (target.options = {});
    let babel = options.babel || (options.babel = {});
    return babel.plugins || (babel.plugins = []);
}
exports.getPluginsArray = getPluginsArray;
function findPluginIndex(plugins, plugin) {
    let pluginName = plugin_names_1.normalizePluginName(plugin);
    return plugins.findIndex(candidate => plugin_names_1.resolvePluginName(candidate) === pluginName);
}
exports.findPluginIndex = findPluginIndex;
